/*Прямое управление для самых распространенных VFD дисплеев. Прошивка для МК ESP32.

- Фиксированная частота обновления дисплея (100Гц для 2029 и 150Гц для остальных)с возможностью регулировки
- Плавная установка яркости от 0 до 100 процентов
- Открытый знакогенератор на 256 символов
- Возможность выводить на дисплей текст, переменные или отдельные символы по их коду

Огромная благодарность за идеи, помощь и советы devICEpro!
AMatroskin 2022 © */

#include "driver/gpio.h"
#include "CharGen.h"

/*Подключить один из файлов, в соответствии с используемой колбой*/
//#include "DriverDN2029DB.h"
//#include "Driver202MD25GINK.h"
#include "Driver202MD20GINK.h" //BOE CIG40-2003N и CIG40-2004N

hw_timer_t * timer = NULL;

void main_task( void *pvParameters ) { //Базовая функция, раелизована ввиде задачи RTOS (Аналог loop()) весь код пишем сюда
  clean_screen ();
  while (1) { //Тут пишем все что хотим, как в loop
    //set_brightness (50); //Яркость в процентах 0 - 100
    vfd_print ("Hello, world!", 0 , 0); //"Текст", номер строки (0, 1), номер столбца (0 - 19)
    vfd_print ("Привет, мир!", 1 , 8);
   
    vTaskDelay (20);
  }
}

void setup() {
  //Serial.begin(115200);
  pinMode(12, OUTPUT); //CLK
  pinMode(13, OUTPUT); //BK
  pinMode(14, OUTPUT); //LAT
  pinMode(15, OUTPUT); //SIN

  init_array(); //Заполняем буфер вывода  (сигнал тактирования, инициализации,выбор сеток, все кроме данных)

  xTaskCreate(main_task,  "main_task", 4000, NULL, 0, NULL ); //Создаем основную задачу
  
/*При текущих настройках таймера частота обновления экрана будет около 90гц 
быстрей нельзя, да и не нужно, при нехватке производительности можно уменьшить частоту срабатывания таймера*/
  timer = timerBegin(0, 2, true);              //80Мгц / 2 = 40Мгц
  timerAttachInterrupt(timer, &onTimer, true); //Функция обработки прерыания
  timerAlarmWrite(timer, 56, true);            //счетчик до прерывания
  timerAlarmEnable(timer);                     // Включаем

}

void loop() {
  //Тут ничего работать не будет
}
