/*Для дисплея NORITAKE Itron DN2029DB, отличается от остальных колб бОльшим числом ножек, т.к. допускает возможность
отдельного управления регистром сеток и регистром анодов. Для подключениея необходимо соединить попарно 
CLK-GCLK, LAT-GLAT, BLK-GBLK, SOUT-GSIN, данные идут на SIN. ВАЖНО! НА НЕКОТОРЫХ ДИСПЛЕЯХ GLAT подключен на плате к +5вольтам,
если это так, отключить, например перерезав дорожку */

uint16_t volatile cntr = 0;   //Счетчик экранного буфера
uint8_t  output_screen_buff_bin [20][294];//Экранный буфер

void parallel_write(uint8_t value) {  //Выод информации на дисплей по прерыванию
  uint64_t output =
    (REG_READ(GPIO_OUT_REG) & ~(0xFF << 12)) | (((uint64_t)value) << 12);
  REG_WRITE(GPIO_OUT_REG, output);
}

void IRAM_ATTR onTimer() { //Обработчик прерывания
  parallel_write (output_screen_buff_bin[0][cntr]);
  (cntr < 5880) ? cntr++ : cntr = 0;
}

void clean_screen () { //Очистка всего экрана
  for (uint8_t i = 0; i < 20; i++) {
    for (int j = 101; j < 293; j++) {
      bitClear(output_screen_buff_bin[i][j], 3);
    }
  }
}

void init_array () { //заполнение массива экранного буфера значениями для инициализации (сигнал тактирования, инициализация, выбор сеток)
  for (uint8_t c = 0; c < 20 ; c++) {  //Обнуляем массив целиком
    for (int i = 6; i < 294; i++) {
      output_screen_buff_bin[c][i] = 0;
    }
  }
  for (uint8_t c = 0; c < 20 ; c++) {     //Прописываем сигнал тактирования CLK (BIT0)
    for (int i = 6; i < 294; i++) {
      ((i & 1) == 1) ? bitClear(output_screen_buff_bin[c][i], 0) : bitSet(output_screen_buff_bin[c][i], 0);
    }
  }
  for (uint8_t i = 0; i < 20; i++) {
    bitSet(output_screen_buff_bin[i][0], 1);
    bitSet(output_screen_buff_bin[i][1], 1); ///инициализация дисплея
    bitSet(output_screen_buff_bin[i][2], 1); //BK   ----____ (BIT1)
    bitSet(output_screen_buff_bin[i][3], 1); //Latch_--_____ (BIT2)
    bitSet(output_screen_buff_bin[i][4], 1);
    bitSet(output_screen_buff_bin[i][2], 2);
    bitSet(output_screen_buff_bin[i][3], 2);
  }
  for (uint8_t i = 0; i < 20; i++) {
    bitSet(output_screen_buff_bin[i][97 - (4 * i)], 3); //Установка номеров сеток (по две на знакоместо)
    bitSet(output_screen_buff_bin[i][98 - (4 * i)], 3); //SIN(BIT3)
    bitSet(output_screen_buff_bin[i][99 - (4 * i)], 3);
    bitSet(output_screen_buff_bin[i][100 - (4 * i)], 3);
  }
}

void vfd_print (char* arr, bool line, uint8_t pos) { //Вывод текстовых символов на экран (знакогенератор devICEpro)
  uint8_t i = 0, w = 0, count = 0, num_buf[20];
  constrain (pos, 0, 19);
  while ((arr[i] != '\0') && ((pos + count) < 20)) {
    if ((arr[i] > 31) && (arr[i] < 127)) { //если это цифры, латиница символы
      num_buf[count] = arr[i];
      for (uint8_t j = 0; j < 7; j++) {
        for (int8_t s = 4; s >= 0; s--) {
          if ((symbol[num_buf[count]][j] >> s) & 0x01) {
            bitSet(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
            bitSet(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
          } else {
            bitClear(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
            bitClear(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
          }
          w++;
        }
      }
      w = 0;
    }
    if (arr[i] == 208) { //Кириллица
      i++;
      if ((arr[i] != 129) && (arr[i] > 143) && (arr[i] < 176)) { //первая часть кириллицы заглавные буквы
        num_buf[count] = ((arr[i]) - 144);
        for (uint8_t j = 0; j < 7; j++) { //35 бит данные верхней строки
          for (int8_t s = 4; s >= 0; s--) {
            if ((symbol[num_buf[count]][j] >> s) & 0x01) {
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            } else {
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            }
            w++;
          }
        }
        w = 0;
      }
      if (arr[i] == 129) { //Буква Ё
        num_buf[count] = 219;
        for (uint8_t j = 0; j < 7; j++) { //35 бит данные верхней строки
          for (int8_t s = 4; s >= 0; s--) {
            if ((symbol[num_buf[count]][j] >> s) & 0x01) {
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            } else {
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            }
            w++;
          }
        }
        w = 0;
      }
      if ((arr[i] > 175) && (arr[i] < 192)) { //перая половина маленьких букв
        num_buf[count] = (arr[i] + 48);
        for (uint8_t j = 0; j < 7; j++) { //35 бит данные верхней строки
          for (int8_t s = 4; s >= 0; s--) {
            if ((symbol[num_buf[count]][j] >> s) & 0x01) {
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            } else {
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            }
            w++;
          }
        }
        w = 0;
      }
    }
    if (arr[i] == 209) { //вторая половина маленьких букв
      i++;
      if ((arr[i] > 127) && (arr[i] < 144)) {
        num_buf[count] = (arr[i] + 112);
        for (uint8_t j = 0; j < 7; j++) { //35 бит данные верхней строки
          for (int8_t s = 4; s >= 0; s--) {
            if ((symbol[num_buf[count]][j] >> s) & 0x01) {
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            } else {
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            }
            w++;
          }
        }
        w = 0;
      }
      if (arr[i] == 145) { //Буква ё
        num_buf[count] = 220;
        for (uint8_t j = 0; j < 7; j++) { //35 бит данные верхней строки
          for (int8_t s = 4; s >= 0; s--) {
            if ((symbol[num_buf[count]][j] >> s) & 0x01) {
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitSet(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            } else {
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (101 + (80 * line))], 3);
              bitClear(output_screen_buff_bin[pos + count][(w * 2) + (102 + (80 * line))], 3);
            }
            w++;
          }
        }
        w = 0;
      }
    }
    i++;
    count++;
  }
}

void vfd_print (int val, bool line, uint8_t pos) { //перегрузка для переменных int
  char arr [10];
  itoa(val, arr, DEC);
  vfd_print (arr, line, pos);
}

void vfd_print (float val, bool line, uint8_t pos) { //перегрузка для переменных float
  char arr [10];
  dtostrf(val, 4, 2, arr);
  vfd_print (arr, line, pos);
}

void vfd_write (uint8_t val, bool line, uint8_t pos) { //Вывод символа по коду (номеру строки в массиве знакогенератора)
  constrain (pos, 0, 19);
  uint8_t w = 0;
  for (uint8_t j = 0; j < 7; j++) { //35 бит данные верхней строки
    for (int8_t s = 4; s >= 0; s--) {
      if ((symbol[val][j] >> s) & 0x01)
      {
        bitSet(output_screen_buff_bin[pos][(w * 2) + (101 + (80 * line))], 3);
        bitSet(output_screen_buff_bin[pos][(w * 2) + (102 + (80 * line))], 3);
      } else {
        bitClear(output_screen_buff_bin[pos][(w * 2) + (101 + (80 * line))], 3);
        bitClear(output_screen_buff_bin[pos][(w * 2) + (102 + (80 * line))], 3);
      }
      w++;
    }
  }
}

void set_brightness (int br) { //Установка яркости 1-100
  br = constrain (br, 1, 100);
  br = map (br, 1, 100, 20, 293);
  for (int i = 0; i < 20; i++) {
    for (int j = 5; j < 294; j++) {
      bitClear(output_screen_buff_bin[i][j], 1);
    }
  }
  for (int i = 0; i < 20; i++) {
    for (int j = br; j < 294; j++) {
      bitSet(output_screen_buff_bin[i][j], 1);
    }
  }
}
